; DAB-USB STANDALONE GERST
; Startup Code
; Interrupt Vektoren

; macros:











; constants:
MAXVOL = 12		; number of volume levels
MAX_CHANNELS = 16	; number of channels per ensemble we can handle + 1
SCAN_TIMEOUT = 20	; how long to wait until all channel data must have arrived

; keyboard values
KEY_LEFT = 8
KEY_UP = 4
KEY_DOWN = 2
KEY_RIGHT = 1

; registers
DPL0 = 0x82
DPH0 = 0x83
ra = 0xe0
ar2 = 2
ar3 = 3

; MMIO
I2CS          = 0x7fa5
I2DAT         = 0x7fa6
LCD_0       = 0x8800 ; unknown
LCD_COMMAND = 0x8802 ; command
LCD_DATA    = 0x8803 ; data
DFIRE = 0x8400
DFIREout = DFIRE+960
DFIREIN = DFIRE+768
DFIREoutptrlo = DFIRE+1016
DFIREoutptrhi = DFIRE+1017
DFIREINptrlo = DFIRE+1018
DFIREINptrhi = DFIRE+1019
DFIREoutmsg = DFIRE+1022
DFIREINmsg = DFIRE+1023


	.module main
;	.globl __sdcc_program_startup
	.include "regezusb.asm"
;	.globl ice_epout_isr


	.area STARTUP (ABS)

	ajmp	startup
	.ds	1
	ljmp	xreti ;; _int0_isr
	.ds	5
	ljmp	xreti ;;_timer0_isr
	.ds	5
	ljmp	xreti ;; _int1_isr
	.ds	5
	ljmp	xreti ;;_timer1_isr
	.ds	5
	ljmp	xreti ;;_ser0_isr
	.ds	5
	ljmp	xreti ;;_timer2_isr
	.ds	5
	ljmp	xreti ;; _resume_isr
	.ds	5
	ljmp	xreti ;;_ser1_isr
	.ds	5
	ljmp	_usb_isr
	.ds	5
	ljmp	xreti ;;_i2c_isr
	.ds	5
	ljmp	xreti ;_int4_isr
	.ds	5
	ljmp	xreti ;;_int5_isr
	.ds	5
	ljmp	xreti ;;_int6_isr



	; USB Vectors
	.org 0x100

_usb_isr:
	ljmp    0; _usb_sudav_isr
	.ds	1
	ljmp	0; _usb_sof_isr
	.ds	1
	ljmp	0; _usb_sutok_isr
	.ds	1
	ljmp	0; _usb_suspend_isr
	.ds	1
	ljmp    0; _usb_usbreset_isr
	.ds	1
	reti
	.ds	3
	reti     ;_usb_ep0in_isr
	.ds	3
	ljmp	0 		;; _usb_ep0out_isr
	.ds	1
	ljmp	0 		;;_usb_ep1in_isr
	.ds	1
	ljmp	0		;; _usb_ep1out_isr
	.ds	1
	ljmp	0 		;;_usb_ep2in_isr
	.ds	1
	ljmp    0 ;; ice_epout_isr	;;_usb_ep2out_isr
	.ds	1
	ljmp	0		;;_usb_ep3in_isr
	.ds	1
	ljmp	0		;_usb_ep3out_isr
	.ds	1
	ljmp	0;_usb_ep4in_isr
	.ds	1
	ljmp	0;_usb_ep4out_isr
	.ds	1
	ljmp	0;_usb_ep5in_isr
	.ds	1
	ljmp	0;_usb_ep5out_isr
	.ds	1
	ljmp	0;_usb_ep6in_isr
	.ds	1
	ljmp	0;_usb_ep6out_isr
	.ds	1
	ljmp	0;_usb_ep7in_isr
	.ds	1
	ljmp	0;_usb_ep7out_isr

	.area   CSEG (CODE,CON,REL)
	ret
	.area   GSINIT (CODE,REL)
	
startup:
	;; allow for all 4 banks to be used (otherwise use eg. 7)
	mov	sp,#0x7f
;	lcall   __sdcc_external_startup
;	mov	a,dpl
;	jz	__sdcc_init_data
;	ljmp	__sdcc_program_startup
;__sdcc_init_data:
;	; linker concatenates all GSINIT areas here
;
;	.area   CSEG (CODE,CON)
;__sdcc_program_startup:

;**********************************************************
; my world starts here
;**********************************************************

	mov DPS, #0	; DON'T TOUCH!
	lcall init_hw
	lcall lcd_init
	lcall splash

	mov volume, #MAXVOL/2
	lcall volume_set_tab
	
	mov cur_ensemble, #0		
start:		
	lcall dfire_tune_n

; clear table indexes
	mov a, #MAX_CHANNELS
	mov dptr, #sid_sub_index
	lcall clear
	mov a, #MAX_CHANNELS
	mov dptr, #sid_sub_data
	lcall clear
	mov a, #MAX_CHANNELS
	mov dptr, #sid_label_index
	lcall clear
;---------------------------------

	lcall scan_for_channels	
; set first channel	
	mov cur_channel, #0
	lcall set_channel
			
; new main program
main_loop:	
	lcall lcd_home
	lcall control_print_ensemble
	lcall lcd_home2
	lcall control_print_channel

	lcall get_figs
	lcall count_channels	; perhaps a new radio station as been established in the meantime...
	dec a
	mov max_channel, a

; keyboard test	
	lcall key_get
	
	cjne a, #KEY_LEFT, not_left
; keyboard left
	lcall volume_updown
	ljmp main_loop
	
not_left:	
	cjne a, #KEY_RIGHT, not_right
; keyboard right
	lcall volume_updown
	ljmp main_loop
	
not_right:	
	cjne a, #KEY_UP, not_up
; keyboard up
	lcall channel_updown
	ljmp main_loop
	
not_up:	
	cjne a, #KEY_DOWN, not_down
; keyboard down
	lcall channel_updown
	ljmp main_loop
	
not_down:
	cjne a, #KEY_LEFT+KEY_RIGHT, not_leftright
	lcall volume_leftright
	ljmp main_loop
	
not_leftright:	
	cjne a, #KEY_UP+KEY_DOWN, not_updown
	lcall next_ensemble
	ljmp main_loop
	
not_updown:
	cjne a, #KEY_LEFT+KEY_RIGHT+KEY_UP+KEY_DOWN, not_all
	lcall easter_egg
	
not_all:
	ljmp main_loop

		
;****************************
next_ensemble:
	inc cur_ensemble
	mov a, cur_ensemble
	cjne a, #3, next_ensemble_1
	mov cur_ensemble, #0
next_ensemble_1:
	ljmp start
	
;****************************
clear:
	push ra
	mov a, #0
	movx @dptr, a
	inc dptr
	pop ra
	dec ra
	jnz clear
	ret

;****************************
easter_egg:
	lcall splash
	mov dptr, #text_easteregg
easter_egg_loop:	
	push DPL0 ; save both DPTR registers
	push DPH0
	push DPL1
	push DPH1

	push DPL0 ; save both DPTR registers
	push DPH0
	push DPL1
	push DPH1

	lcall lcd_home2
	pop DPH1
	pop DPL1
	pop DPH0
	pop DPL0

	mov a, #16
	lcall lcd_puts_a
	lcall wait_3000
	pop DPH1
	pop DPL1
	pop DPH0
	pop DPL0

	inc dptr
	mov a, #16
	movc a, @a+dptr
	jnz easter_egg_loop
	ret
	
splash:	
	lcall lcd_home
	mov dptr, #text_splash
	ljmp lcd_puts
	
;*******************************************
scan_for_channels:
; scan for channels
	mov max_channel, #0
scanloop2:	
	mov scancount, #SCAN_TIMEOUT	; number of turns
scanloop:
	lcall get_figs
	lcall count_channels
	push ra
	clr c
	subb a, max_channel
	jz scan_no_new_channel
	pop ra
	mov max_channel, a
	ljmp scanloop2
scan_no_new_channel:	
	pop ra
	dec scancount
	mov a, scancount
	jnz scanloop

	mov a, max_channel
	jnz signal_ok
	lcall lcd_home
	mov dptr, #text_nosignal
	lcall lcd_puts
	ljmp scanloop2
signal_ok:
	dec max_channel		; maxchannel = number of channels - 1
	ret
	
;*******************************************	
	
control_print_ensemble:	
	mov dptr, #ensemble_label
	ljmp lcd_puts	
control_print_channel:	
	mov dptr, #sid_label_data
	mov a, cur_channel
	rl a
	rl a
	rl a
	rl a
	anl a, #0xf0	; *16
 	add a, DPL0
 	mov DPL0, a
 	jnc cpc_no
 	inc DPH0
cpc_no:		
	mov a, #16
	ljmp lcd_puts_a
	
volume_updown:
	lcall key_get_0			; A = current key
	cjne a, #KEY_LEFT, vol_no_left
; volume down
	dec volume
	mov a, volume
	cjne a, #0xff, volume_not_ff
	mov volume, #0
volume_not_ff:	
	ljmp volume_do_set
vol_no_left:
	cjne a, #KEY_RIGHT, vol_no_right
; volume right
volume_up:
	inc volume
	mov a, volume
	cjne a, #MAXVOL+1, volume_not_max
	mov volume, #MAXVOL
volume_not_max:
volume_do_set:
	lcall volume_set_tab
print_volume:	
	lcall lcd_home
	mov dptr, #text_vol
	lcall lcd_puts
	mov lcd_x, #4
	mov lcd_y, #0
	lcall lcd_set_cursor

	mov a, volume
print_volume_loop:	
	jz print_volume_end
	push ra
	mov a, #0xff
	lcall lcd_putc
	pop ra
	dec a
	ljmp print_volume_loop
print_volume_end:
;	mov a, #MAXVOL
;	lcall lcd_put_spaces
	ljmp volume_updown	; check for next key
vol_no_right:		
	lcall wait_1sec
	ret

volume_leftright: ; mute
	lcall lcd_home
	mov dptr, #text_mute
	lcall lcd_puts	
	lcall volume_mute

wait_1sec:
	lcall wait_3000
	lcall wait_3000
	lcall wait_3000
	lcall wait_3000
	ret		

volume_set_tab:	
	mov a, volume
	mov dptr, #volume_tab
	add a, DPL0
	mov DPL0, a
	jnc ncvol
	inc DPH0
ncvol:
	movx a, @dptr
	ljmp volume_set

i2c_wait:
	mov dptr, #I2CS
	movx a, @dptr

	anl a, #1
	jz i2c_wait
	
	mov dptr, #I2CS
	movx a, @dptr

	anl a, #2
	jz i2c_wait_err
			; error flag (!=0)
	ret	
i2c_wait_err:	
	mov dptr, #I2CS
        mov a, #0x40
        movx @dptr, a

	mov a, #0	; error flag
	ret
	
volume_mute:
	mov a, #0
; set volume to A	
volume_set:
	push ra
	; Startbit setzen, Zieladresse anlegen
	mov dptr, #I2CS
        mov a, #0x80
        movx @dptr, a

	mov dptr, #I2DAT
        mov a, #0x9A
        movx @dptr, a

	
	; auf DONE warten
        lcall i2c_wait
	
	; Volume-Befehl setzen
	mov dptr, #I2DAT
        mov a, #0x02
        movx @dptr, a

		
	; auf DONE warten
        lcall i2c_wait

	; Volume links
	pop ra
	mov dptr, #I2DAT
	movx @dptr, a
        push ra
		
	; auf DONE warten
        lcall i2c_wait

	; Volume rechts
	pop ra
	mov dptr, #I2DAT
	movx @dptr, a
	
	; auf DONE warten
        lcall i2c_wait

	; STOP setzen
	mov dptr, #I2CS
        mov a, #0x40
        movx @dptr, a

	ret

	
;*********************************************************	
channel_updown:	
	lcall key_get_0			; A = current key
	cjne a, #KEY_UP, channel_no_up

	dec cur_channel
	mov a, cur_channel
	cjne a, #0xff, channel_down_1
	mov a, max_channel
	mov cur_channel, a
channel_down_1:
	ljmp set_channel
channel_no_up:	
	inc cur_channel
	mov a, max_channel
	inc a
	clr c
	subb a, cur_channel
	jnz channel_up_1
	mov cur_channel, #0
channel_up_1:	
	ljmp set_channel
			
	
;*********************************************************
set_channel:
	mov a, cur_channel
	mov dptr, #sid_label_index
	movc a, @a+dptr			; A = current SID
	mov cur_sid, a
; search for SID
	mov dptr, #sid_sub_index
	mov r2, #0		; index
ss_loop:
	movx a, @dptr
	jz ss_notfound
	clr c
	subb a, cur_sid
	jz ss_found
	inc dptr
	inc r2			; index
	ljmp ss_loop
ss_notfound:
	ret			; SID has no subchannel ID -> error (ignore)
ss_found:
	mov a, r2
	mov dptr, #sid_sub_data
	movc a, @a+dptr
	ljmp dfire_select_subchannel	
	

;*********************************************************
get_figs:
; start of FIB/FIG parsing, gets new data from dfire and parses it
get_new_data:
	lcall dfire_nop

	; number of FIBs
	mov counter, #12 ; 3

	mov dptr, #DFIRE+1 ; start in dfire memory
fibloop:
; save pointer to beginning of FIB
	mov dptr_fibstart, DPL0
	mov dptr_fibstart+1, DPH0
	
	mov a, #30
	movc a, @a+dptr
	mov b, a
	mov a, #31
	movc a, @a+dptr
	orl a, b
	jnz fibend	; CRC error -> ignore FIB
	
figloop:
; save pointer to beginning of FIG
	mov dptr_figstart, DPL0
	mov dptr_figstart+1, DPH0

; get type and length
	movx a, @dptr		; type and length
	mov typesize, a
	
	jz fibend		; length = 0 (really??)
	cjne a, #0xff, not_fibend
	ljmp fibend
not_fibend:
; **** find out type
	push ra
	rr a
	rr a
	rr a
	rr a
	rr a
	anl a, #7		; type
	mov type, a
	pop ra
; **** find out length
	anl a, #0x1f
	inc ra	
	mov size, a

; **** get ext
	inc dptr
	movx a, @dptr
	mov ext, a
	mov a, type
	jz ext_0
	cjne a, #1, ext_not_1
	mov a, ext
	anl a, #7
	mov ext, a
	ljmp ext_end
ext_0:
	mov a, ext
	anl a, #0x1f
	mov ext, a
	ljmp ext_end
ext_not_1:
	mov ext, #0xff
ext_end:

; ***** test for types
	lcall fig_test

; **** jump to next FIG
	mov DPL0, dptr_figstart
	mov DPH0, dptr_figstart+1

	mov a, size
	add a, DPL0
	mov DPL0, a
	jnc nc
	inc DPH0
nc:
	ljmp figloop
	
fibend:
; **** end of FIB, go to next FIB
	mov DPL0, dptr_fibstart
	mov DPH0, dptr_fibstart+1

	mov a, DPL0
	add a, #32
	mov DPL0, a
	jnc nc2
	inc DPH0
nc2:

	dec counter
	mov a, counter
	jz figend	
	ljmp fibloop

figend:
	ret
	
fig_test:
; interpret type and ext
        mov a, type
        cjne a, #0, type_not_0
	mov a, ext
	cjne a, #2, not_sidsubinfo
	ljmp sidsub;************************************************
not_sidsubinfo:
	mov a, type
type_not_0:
        cjne a, #1, type_not_1
        mov a, ext
        cjne a, #0, not_ensemble_label
	ljmp enslab;************************************************

not_ensemble_label:
	cjne a, #1, not_channel_label
	ljmp chanlab;***********************************************	
not_channel_label:	
type_not_1:                                                                                                                           	
	ret

	
	
	
	
	
	
	
sidsub:
; ******************************************
; * SID & SUBCHANNEL INFO
; ******************************************
        mov DPL0, dptr_figstart
        mov DPH0, dptr_figstart+1
	inc dptr
	movx a, @dptr
	anl a, #0x20	; flag: 1=32 bit, 0=16 bit
	mov pd, a
	inc dptr	; FIG start + 2
	
	mov a, #2
	mov sidsub_counter, a
	
sidsub_loop2:
;	ljmp dfire_print
	mov a, pd
	jz sidsubinfo_16bit
	inc dptr
	inc dptr
sidsubinfo_16bit:
	inc dptr
	movx a, @dptr	; SID (low)
	mov sid, a
	inc dptr
	movx a, @dptr	; noc
	mov noc, a
	inc dptr
	movx a, @dptr
	rr a
	rr a
	rr a
	rr a
	rr a
	rr a
	anl a, #3
	push DPL0 ; save both DPTR registers
	push DPH0
	push DPL1
	push DPH1

	jnz sidsubinfo_isnotaudio
	inc dptr
	movx a, @dptr
	rr a
	rr a
	anl a, #0x3f	; subchannel id	
	mov subchid, a

; search for sid in array
	mov dptr, #sid_sub_index
	mov r2, #0		; index
sidsub_loop:
	movx a, @dptr
	jz sidsub_not_found
	clr c
	subb a, sid
	jz sidsub_found
	inc dptr
	inc r2			; index
	ljmp sidsub_loop
sidsub_not_found:
	mov a, sid
	movx @dptr, a
sidsub_found:
        mov dptr, #sid_sub_data
        mov a, r2		; index
        add a, DPL0
        mov DPL0, a
	jnc sidsub_no		; add to destination address
	inc DPH0
sidsub_no:	
	mov a, subchid
	movx @dptr, a		; store subchid

sidsubinfo_isnotaudio:
	pop DPH1
	pop DPL1
	pop DPH0
	pop DPL0

	mov a, noc
	rl a
	anl a, #0x7e
	add a, DPL0
	mov DPL0, a
	jnc sidsub_no2		; -> pointer to next entry
	inc DPH0
sidsub_no2:
;	; count bytes
;	mov a, noc
;	rl a
;	anl a, #0x7e
;	add a, sidsub_counter
;	inc a
;	inc a			; + 3
;	inc a
;	mov sidsub_counter, a
;	; check for end of FIG
;	mov a, size
;	clr c
;	subb a, sidsub_counter
;	jz sidsub_end
;	jb acc.7, sidsub_end
;; perhaps another block?
;	add a, #-3
;	jb acc.7, sidsub_end
;	
;	mov a, size
;	clr c
;	subb a, sidsub_counter
;	lcall lcd_put_hex
;	ljmp flash
;	
;sidsub_end:	
	ret

enslab:
; ******************************************
; * ENSEMBLE LABEL
; ******************************************
        mov dptr, #ensemble_label
        mov r0, DPL0
        mov r1, DPH0

        mov DPL0, dptr_figstart
        mov DPH0, dptr_figstart+1
        inc dptr
        inc dptr
        inc dptr
        inc dptr

        mov a, #16
        ljmp copy_dptr_r0r1
	
chanlab:
; ******************************************
; * CHANNEL LABEL
; ******************************************
        mov DPL0, dptr_figstart
        mov DPH0, dptr_figstart+1
        inc dptr
        inc dptr
        inc dptr
        movx a, @dptr	; subchannel id
        mov cur_subchid, a
        inc dptr

; search for subchannel id in array	
	push DPL0 ; save both DPTR registers
	push DPH0
	push DPL1
	push DPH1

	mov dptr, #sid_label_index
	mov r2, #0		; index
subchid_loop:
	movx a, @dptr
	jz subchid_not_found
	clr c
	subb a, cur_subchid
	jz subchid_found
	inc dptr
	inc r2			; index
	ljmp subchid_loop
subchid_not_found:
	mov a, cur_subchid
	movx @dptr, a
subchid_found:
        mov dptr, #sid_label_data
        mov r0, DPL0
        mov r1, DPH0
        mov a, r2		; index
        rl a
        rl a
        rl a
        rl a
        anl a, #0xf0		; multiply index with 16
        add a, r0
        mov r0, a
	jnc subchid_no		; add to destination address
	inc r1
subchid_no:	
	pop DPH1
	pop DPL1
	pop DPH0
	pop DPL0

; r0/r1 is now sid_label_data+index*16

        mov a, #16
        ljmp copy_dptr_r0r1

	
	
;**********************************
; return number of channels in A
;**********************************
count_channels:
; search for subchannel id in array	
	mov dptr, #sid_label_index
	mov r2, #0		; index
cc_loop:
	movx a, @dptr
	jz cc_end
	inc dptr
	inc r2			; index
	ljmp cc_loop
cc_end:
	mov a, r2
	ret	
	
;**********************************
; print A bytes
;**********************************
lcd_puts_a:
        push ra
        movx a, @dptr

        push DPL0 ; save both DPTR registers
	push DPH0
	push DPL1
	push DPH1

        lcall lcd_putc
        pop DPH1
	pop DPL1
	pop DPH0
	pop DPL0


        inc dptr
        pop ra
        dec ra
        jz pa_end
        ljmp lcd_puts_a
pa_end:
	ret
;**********************************************************
; copy A bytes from [dptr] to [r0/r1]
;**********************************************************
copy_dptr_r0r1:
        push ra
        movx a, @dptr

        push DPL0 ; save both DPTR registers
	push DPH0
	push DPL1
	push DPH1

        mov DPL0, r0
        mov DPH0, r1
        movx @dptr, a
        inc dptr
        mov r0, DPL0
        mov r1, DPH0
        pop DPH1
	pop DPL1
	pop DPH0
	pop DPL0


        inc dptr
        pop ra
        dec ra
        jz el_end
        ljmp copy_dptr_r0r1
el_end:
	ret

printdptr:
	push DPL0 ; save both DPTR registers
	push DPH0
	push DPL1
	push DPH1

	mov a, DPH0 ; dptr_figstart+1
	lcall lcd_put_hex
	mov a, DPL0 ; dptr_figstart
	lcall lcd_put_hex
	lcall lcd_put_space
	pop DPH1
	pop DPL1
	pop DPH0
	pop DPL0

	ret
	



;	mov a, #0xEA
;	lcall lcd_put_hex

;	lcall dab_get_dab_status


;	mov dptr, #string
;	lcall lcd_puts


;	mov dptr, #string
;	lcall lcd_puts


;inf:
;	lcall key_get
;	orl a, #0x40
;	lcall lcd_putc
;	ljmp inf

flash:
infinite:
        mov     dptr,#OUTA
        mov     a,#0x80
        movx    @dptr,a
	lcall wait_3000
        mov     dptr,#OUTA
        mov     a,#0x40
        movx    @dptr,a
	lcall wait_3000

	ljmp  infinite	

;	lcall	_real_main
;	ajmp	.
xreti:
	reti


;****************************
; DFIRE
;****************************
dfire_init:
	mov dptr, #DFIREINptrlo
        mov a, #0
        movx @dptr, a
	; set response pointer to beginning
	mov dptr, #DFIREINptrhi
        mov a, #0
        movx @dptr, a

	mov dptr, #DFIREIN
        mov a, #0
        movx @dptr, a
		; clear first two bytes of response
	inc dptr
	movx @dptr, a

	ret

dfire_wait:
	mov dptr, #DFIREINmsg
	movx a, @dptr

	jnz dfire_wait_2
	lcall small_wait
	ajmp dfire_wait
dfire_wait_2:
	ret

dfire_tune_n:
	mov a, cur_ensemble
	jz dfire_tune_12D
	dec a
	jz dfire_tune_LG
dfire_tune_11D:	
	mov r0, #0x70
	mov r1, #0x36
	mov r2, #0x37
	ljmp dfire_tune
	
dfire_tune_12D:	
	mov r0, #0x70
	mov r1, #0x37
	mov r2, #0xed
	ljmp dfire_tune
	
dfire_tune_LG:	
	mov r0, #0x71
	mov r1, #0x65
	mov r2, #0x3c
	ljmp dfire_tune
	
; tune to r0/r1/r2
dfire_tune:
	lcall dfire_command_init
	mov dptr, #DFIREout
        mov a, #1
        movx @dptr, a
	; TUNE command
	inc dptr
	mov a, #2
	movx @dptr, a

	inc dptr
	mov a, #0
	movx @dptr, a

	inc dptr
	mov a, #4
	movx @dptr, a

	inc dptr
	mov a, #3
	movx @dptr, a


	mov a, r0
	inc dptr
	movx @dptr, a

	mov a, r1
	inc dptr
	movx @dptr, a

	mov a, r2
	inc dptr
	movx @dptr, a


	mov a, #8
	lcall dfire_command_send
	
	lcall wait_1sec
	lcall wait_1sec
	ret

dfire_command_init:
	mov dptr, #DFIREINmsg
	movx a, @dptr

	mov dptr, #DFIREINmsg
        mov a, #0
        movx @dptr, a


	mov dptr, #DFIREIN
        mov a, #0
        movx @dptr, a
		; clear last "ACCEPTED" message
	inc dptr
	movx @dptr, a

	mov dptr, #DFIREINmsg
        mov a, #0
        movx @dptr, a
	; clear status
	ret

dfire_command_send:
	mov b, a
	mov dptr, #DFIREINptrlo
        mov a, #0
        movx @dptr, a
	; data input pointers
	mov dptr, #DFIREINptrhi
        mov a, #0
        movx @dptr, a

	mov dptr, #DFIREoutptrlo
        mov a, #0
        movx @dptr, a

	mov a, b
	mov dptr, #DFIREoutptrhi
        movx @dptr, a
	; length
	mov dptr, #DFIREoutmsg
        movx @dptr, a
	; start
	ljmp dfire_wait

dfire_get_dab_status:
	lcall dfire_command_init
	mov dptr, #DFIREout
        mov a, #1
        movx @dptr, a
	; write command into buffer
	inc dptr
	mov a, #0xA
	movx @dptr, a

	inc dptr
	mov a, #0
	movx @dptr, a

	inc dptr
	mov a, #0
	movx @dptr, a

	mov a, #4
	ljmp dfire_command_send

dfire_select_subchannel:
	push ra
	lcall dfire_command_init
	mov dptr, #DFIREout
        mov a, #1
        movx @dptr, a
	; write command into buffer
	inc dptr
	mov a, #0x6
	movx @dptr, a

	inc dptr
	mov a, #0
	movx @dptr, a

	inc dptr
	mov a, #0xB
	movx @dptr, a

	inc dptr
	mov a, #0x8
	movx @dptr, a

	inc dptr
	mov a, #0x3
	movx @dptr, a

	inc dptr
	mov a, #0x0
	movx @dptr, a

	inc dptr
	mov a, #0x3
	movx @dptr, a

	inc dptr
	mov a, #0x1
	movx @dptr, a

	inc dptr
	mov a, #0x0
	movx @dptr, a

	inc dptr
	mov a, #0x0
	movx @dptr, a

	inc dptr
	mov a, #0x0
	movx @dptr, a

	inc dptr
	mov a, #0x0
	movx @dptr, a

	inc dptr
	mov a, #0x0
	movx @dptr, a

	pop ra
	inc dptr
	movx @dptr, a

	mov a, #15
	lcall dfire_command_send
	ret

dfire_nop:
	lcall dfire_command_init
	mov dptr, #DFIREout
        mov a, #0x10
        movx @dptr, a

	inc dptr
	mov a, #0
	movx @dptr, a

	inc dptr
	mov a, #0
	movx @dptr, a

	inc dptr
	mov a, #0
	movx @dptr, a


	mov a, #4
	ljmp dfire_command_send

dfire_print:
	push DPL0 ; save both DPTR registers
	push DPH0
	push DPL1
	push DPH1

	lcall lcd_home

	movx a, @dptr
	lcall lcd_put_hex
	inc dptr
	movx a, @dptr
	lcall lcd_put_hex
	inc dptr
	movx a, @dptr
	lcall lcd_put_hex
	inc dptr
	movx a, @dptr
	lcall lcd_put_hex
	inc dptr
	movx a, @dptr
	lcall lcd_put_hex
	inc dptr
	movx a, @dptr
	lcall lcd_put_hex
	inc dptr
	movx a, @dptr
	lcall lcd_put_hex
	inc dptr
	movx a, @dptr
	lcall lcd_put_hex

	movx a, @dptr
	lcall lcd_put_hex
	inc dptr
	movx a, @dptr
	lcall lcd_put_hex
	inc dptr
	movx a, @dptr
	lcall lcd_put_hex
	inc dptr
	movx a, @dptr
	lcall lcd_put_hex
	inc dptr
	movx a, @dptr
	lcall lcd_put_hex
	inc dptr
	movx a, @dptr
	lcall lcd_put_hex
	inc dptr
	movx a, @dptr
	lcall lcd_put_hex
	inc dptr
	movx a, @dptr
	lcall lcd_put_hex

	pop DPH1
	pop DPL1
	pop DPH0
	pop DPL0

	ljmp dfire_print


key_get:
	lcall key_get_bitfield
	ljmp key_get_0
		
;**********************************************************
; gets pressed (down&up or repeat) keys
;  B and R0, R2, R3, R4, R5, R6 are destroyed
;  result in A
;  1000 left
;  0100 up
;  0010 down
;  0001 right
;   and combinations thereof
;**********************************************************
key_wait_get:

	lcall key_get_bitfield
	jz key_get
key_get_0:
	mov r6, a	; save initial key

        mov r2,#10
key_get_1:
        mov r3,#200
key_get_2:
        push ar2
        push ar3
        lcall wait_0_1ms

	lcall key_get_bitfield
	mov r5, a	; rescue

	xrl a, r6	; old key = new key?
	jz key_get_3	; yes, no change

	mov a, r5	; new key = 0?
	jz key_get_4	; yes, key released

	orl a, r6	; pretend that both keys have
	mov r6, a	; been pressed from the beginning

key_get_3:
        pop ar3
        pop ar2
        djnz r3, key_get_2
        djnz r2, key_get_1
; pressed long enough -> repeat
	mov a, r6
	ret
key_get_4:
	pop ar3		; clear stack
	pop ar3
	mov a, r6
	ret

;**********************************************************
; gets a bitfield with currently pressed down keys
;  B and R0 are destroyed
;  result in A
;  1000 left
;  0100 up
;  0010 down
;  0001 right
;**********************************************************
key_get_bitfield:
	mov a, #1	; mask 1
	lcall key_get_bitfield_2
	anl a, #14	; clear mask bit
	mov r0, a
	mov a, #4	; mask 2
	lcall key_get_bitfield_2
	anl a, #11	; clear mask bit
	rr a
	orl a, r0	; combine with result 1
	anl a, #0xf	; clear unimportant bits (necessary!)
	mov r0, a
	add a, #-7	; right&down is 7, but should be 3
	jnz key_get_bitfield_1
	mov r0, #3
key_get_bitfield_1:
	mov a, r0
	ret
key_get_bitfield_2:
	mov b, a

	mov a, #0x0f	; clear all 4 bits
	mov dptr, #OEB
	movx @dptr, a
	mov a, #0
	mov dptr, #OUTB
	movx @dptr, a

	mov a, b	; set one bit
	mov dptr, #OEB
	movx @dptr, a
	mov dptr, #OUTB
	movx @dptr, a

	mov dptr, #PINSB; get input
	movx a, @dptr
	anl a, #0x0f	; only bits #0 - #3 are interesting
	ret

;**********************************************************
; tiny delay
;**********************************************************
small_wait:
        mov r2,#100
small_wait_loop:
        djnz r2,small_wait_loop
	ret

;**********************************************************
; small delay
;**********************************************************
wait_0_1ms:
	mov     dptr,#(0xffff - 60)
	mov     r4,#5;
loop:
	inc     dptr            ; 3 cycles
	mov     a,dpl           ; 2 cycles
	orl     a,dph           ; 2 cycles
	jnz     loop            ; 3 cycles
	ret

;**********************************************************
; delay
;**********************************************************
wait_3000:
        mov r2,#10;
wait_3000_1:
        mov r3,#200;
wait_3000_2:
        push ar2;
        push ar3;
        lcall wait_0_1ms;
        pop ar3;
        pop ar2;
        djnz r3,wait_3000_2;
        djnz r2,wait_3000_1;
	ret

;**********************************************************
; initialize LCD, cursor on, forward, CLS
;**********************************************************
lcd_init:
	mov	dptr, #LCD_0
        mov	a, #0x1d ; ???
	movx	@dptr, a
	lcall	small_wait
	mov	dptr, #LCD_COMMAND
        mov	a, #0x3c ; data length, display lines, character font
	movx	@dptr, a
	lcall	small_wait
	mov	dptr, #LCD_COMMAND
        mov	a, #6 ; cursor move, display shift
	movx	@dptr, a
	lcall	small_wait
	mov	dptr, #LCD_COMMAND
        mov	a, #1 ; clear
	movx	@dptr, a
	lcall	wait_3000
	mov	dptr, #LCD_COMMAND
        mov	a, #0xf ; display on, cursor blink
	movx	@dptr, a
	
	mov lcd_x, #0
	mov lcd_y, #0
	ljmp	small_wait

;**********************************************************
; clear LCD
;**********************************************************
lcd_clear:
	mov dptr,#LCD_COMMAND
	mov a,#1
	movx @dptr,a
	ljmp wait_3000

lcd_put_spaces:
	jz lcd_put_spaces_end
	push ra
	lcall lcd_put_space
	pop ra
	dec a
	ljmp lcd_put_spaces
lcd_put_spaces_end:
	ret
		
lcd_put_space:
	mov a, #0x20
;**********************************************************
; output character in A, never update cursor to next line
;**********************************************************
lcd_putc:
	push DPL0 ; save both DPTR registers
	push DPH0
	push DPL1
	push DPH1

	mov dptr,#LCD_DATA
        movx @dptr,a
	lcall small_wait
	
	inc lcd_x
	mov a, lcd_x
	cjne a, #16, lcd_putc1; not at end of line
 	mov lcd_x, #0
 	inc lcd_y
 	mov a, lcd_y
 	cjne a, #2, lcd_putc2
 	mov lcd_y, #0
lcd_putc2: 	
	lcall lcd_set_cursor
lcd_putc1:	
	pop DPH1
	pop DPL1
	pop DPH0
	pop DPL0

	ret

lcd_putc_protected:
	jb acc.7, lcd_putc_protected1
	add a, #-32
	jb acc.7, lcd_putc_protected1
	add a, #32
	ljmp lcd_putc
lcd_putc_protected1:
	push ra
	mov a, #94
	lcall lcd_putc
	pop ra
	ljmp lcd_put_hex
	
;**********************************************************
; output string in dptr
;  destroys R0/R1
;**********************************************************
lcd_puts:
	movx a, @dptr
	jz lcd_puts_end
	lcall lcd_putc
	inc dptr
	ljmp lcd_puts
lcd_puts_end:
	ret

lcd_clrhome:
	lcall lcd_clear
lcd_home:
	mov lcd_x, #0
	mov lcd_y, #0
lcd_set_cursor:
	mov a, lcd_y
	jz lcd_set_cursor1
	mov a, #0x40
lcd_set_cursor1:
	add a, lcd_x	
	push DPL0 ; save both DPTR registers
	push DPH0
	push DPL1
	push DPH1

	mov dptr,#LCD_COMMAND
	orl a, #128
	movx @dptr, a
	lcall small_wait	
	pop DPH1
	pop DPL1
	pop DPH0
	pop DPL0

	ret
	
lcd_home2:
	mov lcd_x, #0
	mov lcd_y, #1
	ljmp lcd_set_cursor	

;**********************************************************
; output A in binary notation
;  destroys r0
;**********************************************************
lcd_put_binary:

	mov r0, #8
lcd_put_binary_1:
	rlc a
	push ra
	jc lcd_put_binary_2
	mov a, #0x30
	ljmp lcd_put_binary_3
lcd_put_binary_2:
	mov a, #0x31
lcd_put_binary_3:
	lcall lcd_putc
	dec r0
	mov a, r0
	jz lcd_put_binary_4
	pop ra
	ljmp lcd_put_binary_1
lcd_put_binary_4:
	pop ra
	ret

;**********************************************************
; output A in hexadecimal notation
;  
;**********************************************************
lcd_put_hex:
	push ra
	rr a
	rr a
	rr a
	rr a
	lcall lcd_put_hex_4
	pop ra
lcd_put_hex_4:
	anl a, #0xf
	add a, #-10
	jb acc.7, lcd_put_hex_4_neg
; A-F
li:
;	ljmp li
	add a, #0x41
	ljmp lcd_putc
lcd_put_hex_4_neg:
; 0-9
lj:
;	ljmp lj
	add a, #0x3a
	ljmp lcd_putc


init_hw:
	mov dptr, #USBCS
        mov a, #4
        movx @dptr, a

	mov dptr, #ISOCTL
        mov a, #1
        movx @dptr, a
;   /* disable ISO endpoints, enable extra 2K */
	mov dptr, #USBBAV
        mov a, #0
        movx @dptr, a
;   /* enable autovector, disable breakpoint logic */
	mov dptr, #CPUCS
        mov a, #2
        movx @dptr, a
;      /* CLK24 output enable */
	mov dptr, #CKCON
        mov a, #0x39
        movx @dptr, a
; /* one external wait state, to avoid chip bugs */
 
	mov dptr, #PCON
        mov a, #0
        movx @dptr, a
;  /* SMOD0=0 */
 
;        /* Port A(7:0): LED1 LED2 FRD FWR CS OE xil_data xil_cclk*/
	mov dptr, #PORTACFG
        mov a, #0x3C
        movx @dptr, a
;     // enable FRD FWR CS OE
	mov dptr, #OEA
        mov a, #0xff
        movx @dptr, a
;
	mov dptr, #OUTA
        mov a, #0x80
        movx @dptr, a
;
; 
;        /* Port B(7:0): x I6 I5 I4 KEY3 KEY2 KEY1 KEY0 */
	mov dptr, #PORTBCFG
        mov a, #0x70
        movx @dptr, a
;
	mov dptr, #OEB
        mov a, #0x8f
        movx @dptr, a
;
	mov dptr, #OUTB
        mov a, #0x0
        movx @dptr, a
;
 
;        /* Port C(7:0): XX XX XX XX XIL_RESET XX XX XX */
	mov dptr, #OUTC
        mov a, #0x28
        movx @dptr, a
;
	mov dptr, #PORTCCFG
        mov a, #0xc2
        movx @dptr, a
;  // TXD on
	mov dptr, #OUTC
        mov a, #0x28
        movx @dptr, a
;
	mov dptr, #OEC
        mov a, #0x28
        movx @dptr, a
;
 
	mov dptr, #INISOVAL
        mov a, #0
        movx @dptr, a
;
	mov dptr, #OUTISOVAL
        mov a, #0
        movx @dptr, a
;
 
	mov dptr, #USBPAIR
        mov a, #0x00
        movx @dptr, a
;
 
	mov dptr, #IE
        mov a, #0x80
        movx @dptr, a
;       // global int enable
	mov dptr, #EIP
        mov a, #0x10
        movx @dptr, a
;      // Int6/4 have high priority
	mov dptr, #USBIEN
        mov a, #0
        movx @dptr, a
;      // disable SUDAV interrupt
	mov dptr, #FASTXFR
        mov a, #0x88
        movx @dptr, a
;  // FRD Mode 01
	mov dptr, #USBIRQ
        mov a, #0x00
        movx @dptr, a
;
 
;	mov dptr, #eie
        mov a, #0x00
        movx @dptr, a
 ;     // Disable USB IRQ         

	ret

text_easteregg:
 .asciz "                This great piece of software was brought to you by Michael Steil and Alexander Mayer.                "
text_splash:
; .asciz "DAB Firmware    (C)2002mist&morn"
  .asciz "6502forever     (C)2002mist&morn"
text_nosignal:
 .asciz "   NO SIGNAL    "

text_vol:
 .asciz "Vol             "
text_mute:
 .asciz "     -MUTE-     "
   	
ensemble_label:
 .asciz "unknown         "

volume_tab:
 .byte 0
 .byte 10
 .byte 20
 .byte 30
 .byte 35
 .byte 40
 .byte 45
 .byte 50
 .byte 55
 .byte 57
 .byte 59
 .byte 61
 .byte 63

sid_sub_index:
	.ds MAX_CHANNELS
sid_sub_data:
	.ds MAX_CHANNELS
	
sid_label_index:
	.ds MAX_CHANNELS
sid_label_data:
	.ds MAX_CHANNELS*16

.area DSEG	(DATA)
lcd_x:
	.ds 1
lcd_y:
	.ds 1
typesize:
	.ds 1
counter:
	.ds 1
size:
	.ds 1
type:
	.ds 1
ext:	
	.ds 1
dptr_fibstart:
	.ds 2
dptr_figstart:
	.ds 2
volume:
	.ds 1
cur_subchid:
	.ds 1	
pd:
	.ds 1	
noc:
	.ds 1
sid:
	.ds 1
subchid:
	.ds 1	
sidsub_counter:
	.ds 1
cur_ensemble:
	.ds 1
cur_channel:
	.ds 1
cur_sid:
	.ds 1
max_channel:
	.ds 1	
scancount:
	.ds 1